Index: LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 774)
+++ LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 949)
@@ -221,5 +221,5 @@
 c$OMP MASTER
       OMP_CHUNK=5
-c$OMP END MASTER	  
+c$OMP END MASTER  
 c-----------------------------------------------------------------------
 c   On initialise la pression et la fonction d'Exner :
@@ -287,11 +287,11 @@
 
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)         
-	 DO l=1,llm      
+         DO l=1,llm      
            ije=ij_end
-	   ucovm1   (ijb:ije,l) = ucov  (ijb:ije,l)
+           ucovm1   (ijb:ije,l) = ucov  (ijb:ije,l)
            tetam1   (ijb:ije,l) = teta  (ijb:ije,l)
            massem1  (ijb:ije,l) = masse (ijb:ije,l)
            finvmaold(ijb:ije,l)=masse(ijb:ije,l)
-	         
+                 
            if (pole_sud) ije=ij_end-iip1
            vcovm1(ijb:ije,l) = vcov  (ijb:ije,l)
@@ -299,5 +299,5 @@
 
          ENDDO
-c$OMP ENDDO	  
+c$OMP ENDDO          
 
 
@@ -376,5 +376,5 @@
       IF (ok_start_timer) THEN
         CALL InitTime
-	ok_start_timer=.FALSE.
+        ok_start_timer=.FALSE.
       ENDIF      
 c$OMP END MASTER      
@@ -390,8 +390,8 @@
         if (Verbose) then
         
-	print *,'*********************************'
-	print *,'******    TIMER CALDYN     ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_caldyn(i),
+        print *,'*********************************'
+        print *,'******    TIMER CALDYN     ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_caldyn(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_caldyn(i),timer_caldyn,i),
@@ -400,7 +400,7 @@
       
         print *,'*********************************'
-	print *,'******    TIMER VANLEER    ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_vanleer(i),
+        print *,'******    TIMER VANLEER    ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_vanleer(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_vanleer(i),timer_vanleer,i),
@@ -409,7 +409,7 @@
       
         print *,'*********************************'
-	print *,'******    TIMER DISSIP    ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_dissip(i),
+        print *,'******    TIMER DISSIP    ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_dissip(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_dissip(i),timer_dissip,i),
@@ -417,12 +417,12 @@
         enddo
         
-	if (mpi_rank==0) call WriteBands
-	
+        if (mpi_rank==0) call WriteBands
+        
        endif
        
-	 call AdjustBands_caldyn
+         call AdjustBands_caldyn
          if (mpi_rank==0) call WriteBands
-	 
-	 call Register_SwapFieldHallo(ucov,ucov,ip1jmp1,llm,
+         
+         call Register_SwapFieldHallo(ucov,ucov,ip1jmp1,llm,
      &                                jj_Nb_caldyn,0,0,TestRequest)
          call Register_SwapFieldHallo(ucovm1,ucovm1,ip1jmp1,llm,
@@ -457,5 +457,5 @@
      &                                jj_Nb_caldyn,0,0,TestRequest)
  
-	do j=1,nqmx
+        do j=1,nqmx
          call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
      &                                jj_nb_caldyn,0,0,TestRequest)
@@ -466,6 +466,6 @@
          call WaitRequest(TestRequest)
          
-	call AdjustBands_dissip
-	call AdjustBands_physic
+        call AdjustBands_dissip
+        call AdjustBands_physic
 
       endif
@@ -500,5 +500,5 @@
 
       
-      if (debug) then	
+      if (debug) then        
         call WriteField_p('ucov',reshape(ucov,(/iip1,jmp1,llm/)))
         call WriteField_p('vcov',reshape(vcov,(/iip1,jjm,llm/)))
@@ -506,5 +506,5 @@
         call WriteField_p('ps',reshape(ps,(/iip1,jmp1/)))
         call WriteField_p('masse',reshape(masse,(/iip1,jmp1,llm/)))
-	call WriteField_p('pk',reshape(pk,(/iip1,jmp1,llm/)))
+        call WriteField_p('pk',reshape(pk,(/iip1,jmp1,llm/)))
         call WriteField_p('pks',reshape(pks,(/iip1,jmp1/)))
         call WriteField_p('pkf',reshape(pkf,(/iip1,jmp1,llm/)))
@@ -521,5 +521,5 @@
 
 c$OMP MASTER
-      print*,"Iteration No",True_itau
+c     print*,"Iteration No",True_itau
 
 
@@ -659,5 +659,5 @@
 c$OMP MASTER
          call suspend_timer(timer_caldyn)
-         print*,'Entree dans la physique : Iteration No ',true_itau
+c        print*,'Entree dans la physique : Iteration No ',true_itau
 c$OMP END MASTER
 
@@ -691,5 +691,5 @@
         call VTb(VThallo)
         call SetTag(Request_physic,800)
-	
+        
         call Register_SwapFieldHallo(ucov,ucov,ip1jmp1,llm,
      *                               jj_Nb_physic,2,2,Request_physic)
@@ -716,5 +716,5 @@
      *                               jj_Nb_physic,2,2,Request_physic)
         
-c	call SetDistrib(jj_nb_vanleer)
+c        call SetDistrib(jj_nb_vanleer)
         do j=1,nqmx
  
@@ -727,15 +727,15 @@
 #endif
         call SetDistrib(jj_nb_Physic)
-	
+        
         call SendRequest(Request_Physic)
         call WaitRequest(Request_Physic)       
-	
-	call VTe(VThallo)
-	
-	call VTb(VTphysiq)
-c$OMP END MASTER
-c$OMP BARRIER
-
-cc$OMP MASTER	
+        
+        call VTe(VThallo)
+        
+        call VTb(VTphysiq)
+c$OMP END MASTER
+c$OMP BARRIER
+
+cc$OMP MASTER        
 c      call WriteField_p('ucovfi',reshape(ucov,(/iip1,jmp1,llm/)))
 c      call WriteField_p('vcovfi',reshape(vcov,(/iip1,jjm,llm/)))
@@ -745,5 +745,5 @@
 cc$OMP END MASTER
 cc$OMP BARRIER
-	
+        
         CALL calfis_p( nq, lafin ,rdayvrai,time  ,
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
@@ -768,9 +768,9 @@
           dpfi_tmp(1:iip1)     = dpfi(ijb:ijb+iim)  
 c$OMP END MASTER
-	endif
-
-c$OMP BARRIER
-c$OMP MASTER
-	call SetDistrib(jj_nb_Physic_bis)
+        endif
+
+c$OMP BARRIER
+c$OMP MASTER
+        call SetDistrib(jj_nb_Physic_bis)
 
         call VTb(VThallo)
@@ -800,8 +800,8 @@
         call SetDistrib(jj_nb_Physic)
 c$OMP END MASTER
-c$OMP BARRIER	
-	        ijb=ij_begin
-	if (.not. pole_nord) then
-	
+c$OMP BARRIER        
+                ijb=ij_begin
+        if (.not. pole_nord) then
+        
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO l=1,llm
@@ -818,8 +818,8 @@
           dpfi(ijb:ijb+iim)   = dpfi(ijb:ijb+iim)+ dpfi_tmp(1:iip1)
 c$OMP END MASTER
-	  
+          
         endif
 c$OMP BARRIER
-cc$OMP MASTER	
+cc$OMP MASTER        
 c      call WriteField_p('dufi',reshape(dufi,(/iip1,jmp1,llm/)))
 c      call WriteField_p('dvfi',reshape(dvfi,(/iip1,jjm,llm/)))
@@ -924,8 +924,8 @@
 c$OMP MASTER
          call resume_timer(timer_caldyn)
-	 if (FirstPhysic) then
-	   ok_start_timer=.TRUE.
-	   FirstPhysic=.false.
-	 endif
+         if (FirstPhysic) then
+           ok_start_timer=.TRUE.
+           FirstPhysic=.false.
+         endif
 c$OMP END MASTER
        ENDIF
@@ -947,8 +947,8 @@
 c$OMP MASTER
         call suspend_timer(timer_caldyn)
-	
-        print*,'Entree dans la dissipation : Iteration No ',true_itau
+        
+c       print*,'Entree dans la dissipation : Iteration No ',true_itau
 c   calcul de l'energie cinetique avant dissipation
-        print *,'Passage dans la dissipation'
+c       print *,'Passage dans la dissipation'
 
         call VTb(VThallo)
@@ -976,9 +976,9 @@
         call SetDistrib(jj_Nb_dissip)
         
-	call VTe(VThallo)
+        call VTe(VThallo)
 
         call VTb(VTdissipation)
         
-	call start_timer(timer_dissip)
+        call start_timer(timer_dissip)
 c$OMP END MASTER
 c$OMP BARRIER
@@ -991,17 +991,17 @@
         CALL dissip_p(vcov,ucov,teta,p,dvdis,dudis,dtetadis)
          
-	ijb=ij_begin
-	ije=ij_end
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	
-	DO l=1,llm
-	  ucov(ijb:ije,l)=ucov(ijb:ije,l)+dudis(ijb:ije,l)
+        ijb=ij_begin
+        ije=ij_end
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)        
+        DO l=1,llm
+          ucov(ijb:ije,l)=ucov(ijb:ije,l)+dudis(ijb:ije,l)
         ENDDO
-c$OMP END DO NOWAIT	
-	if (pole_sud) ije=ije-iip1
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	
-	DO l=1,llm
-	  vcov(ijb:ije,l)=vcov(ijb:ije,l)+dvdis(ijb:ije,l)
+c$OMP END DO NOWAIT        
+        if (pole_sud) ije=ije-iip1
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)        
+        DO l=1,llm
+          vcov(ijb:ije,l)=vcov(ijb:ije,l)+dvdis(ijb:ije,l)
         ENDDO
-c$OMP END DO NOWAIT	
+c$OMP END DO NOWAIT        
 
 c       teta=teta+dtetadis
@@ -1015,5 +1015,5 @@
 c$OMP MASTER
             call suspend_timer(timer_dissip)
-	    call VTb(VThallo)
+            call VTb(VThallo)
 
             call Register_Hallo(ucov,ip1jmp1,llm,1,1,1,1,Request_Dissip)
@@ -1024,29 +1024,29 @@
             call resume_timer(timer_dissip)
 c$OMP END MASTER
-c$OMP BARRIER	    
+c$OMP BARRIER            
             call covcont_p(llm,ucov,vcov,ucont,vcont)
             call enercin_p(vcov,ucov,vcont,ucont,ecin)
             
-	    ijb=ij_begin
-	    ije=ij_end
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	    
-	    do l=1,llm
-	      do ij=ijb,ije
-	        dtetaecdt(ij,l)= (ecin0(ij,l)-ecin(ij,l))/ pk(ij,l)
-		dtetadis(ij,l)=dtetadis(ij,l)+dtetaecdt(ij,l)
+            ijb=ij_begin
+            ije=ij_end
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)            
+            do l=1,llm
+              do ij=ijb,ije
+                dtetaecdt(ij,l)= (ecin0(ij,l)-ecin(ij,l))/ pk(ij,l)
+                dtetadis(ij,l)=dtetadis(ij,l)+dtetaecdt(ij,l)
               enddo
-	    enddo
-c$OMP END DO NOWAIT	    
+            enddo
+c$OMP END DO NOWAIT            
        endif
 
        ijb=ij_begin
        ije=ij_end
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	    
-	 do l=1,llm
-	   do ij=ijb,ije
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)            
+         do l=1,llm
+           do ij=ijb,ije
               teta(ij,l)=teta(ij,l)+dtetadis(ij,l)
-	   enddo
-	 enddo
-c$OMP END DO NOWAIT	 
+           enddo
+         enddo
+c$OMP END DO NOWAIT         
 c------------------------------------------------------------------------
 
@@ -1117,5 +1117,5 @@
 
         call stop_timer(timer_dissip)
-	
+        
         call VTb(VThallo)
 
@@ -1140,5 +1140,5 @@
         call VTe(VThallo)
         call resume_timer(timer_caldyn)
-	print *,'fin dissipation'
+        print *,'fin dissipation'
 c$OMP END MASTER
       END IF
@@ -1171,7 +1171,7 @@
         
         print *,'*********************************'
-	print *,'******    TIMER CALDYN     ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_caldyn(i),
+        print *,'******    TIMER CALDYN     ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_caldyn(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_caldyn(i),timer_caldyn,i)
@@ -1179,7 +1179,7 @@
       
         print *,'*********************************'
-	print *,'******    TIMER VANLEER    ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_vanleer(i),
+        print *,'******    TIMER VANLEER    ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_vanleer(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_vanleer(i),timer_vanleer,i)
@@ -1187,19 +1187,19 @@
       
         print *,'*********************************'
-	print *,'******    TIMER DISSIP    ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_dissip(i),
+        print *,'******    TIMER DISSIP    ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_dissip(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_dissip(i),timer_dissip,i)
         enddo
-	
-	print *,'*********************************'
-	print *,'******    TIMER PHYSIC    ******'
-	do i=0,mpi_size-1
-	  print *,'proc',i,' :   Nb Bandes  :',jj_nb_physic(i),
+        
+        print *,'*********************************'
+        print *,'******    TIMER PHYSIC    ******'
+        do i=0,mpi_size-1
+          print *,'proc',i,' :   Nb Bandes  :',jj_nb_physic(i),
      &            '  : temps moyen :',
      &             timer_average(jj_nb_physic(i),timer_physic,i)
         enddo
-	
+        
       endif  
       
@@ -1211,5 +1211,5 @@
         call finalize_parallel
 c$OMP END MASTER
-	RETURN
+        RETURN
       ENDIF
       
@@ -1275,31 +1275,31 @@
         CALL geopot_p  ( ip1jmp1, teta  , pk , pks,  phis  , phi )
        
-cym	unat=0.
-	
-	ijb=ij_begin
-	ije=ij_end
-	
-	if (pole_nord) then
-	  ijb=ij_begin+iip1
-	  unat(1:iip1,:)=0.
-	endif
-	
-	if (pole_sud) then 
-	  ije=ij_end-iip1
-	  unat(ij_end-iip1+1:ij_end,:)=0.
-	endif
-	    
+cym        unat=0.
+        
+        ijb=ij_begin
+        ije=ij_end
+        
+        if (pole_nord) then
+          ijb=ij_begin+iip1
+          unat(1:iip1,:)=0.
+        endif
+        
+        if (pole_sud) then 
+          ije=ij_end-iip1
+          unat(ij_end-iip1+1:ij_end,:)=0.
+        endif
+            
         do l=1,llm
            unat(ijb:ije,l)=ucov(ijb:ije,l)/cu(ijb:ije)
         enddo
 
-	ijb=ij_begin
-	ije=ij_end
-	if (pole_sud) ije=ij_end-iip1
-	
-	do l=1,llm
+        ijb=ij_begin
+        ije=ij_end
+        if (pole_sud) ije=ij_end-iip1
+        
+        do l=1,llm
            vnat(ijb:ije,l)=vcov(ijb:ije,l)/cv(ijb:ije)
         enddo
-	
+        
 #ifdef CPP_IOIPSL
  
@@ -1387,5 +1387,5 @@
                IF( itau. EQ. itaufinp1 ) then  
 c$OMP MASTER
-	         call finalize_parallel
+                 call finalize_parallel
 c$OMP END MASTER
                  abort_message = 'Simulation finished'
@@ -1426,26 +1426,26 @@
 
 cym        unat=0.
-	ijb=ij_begin
-	ije=ij_end
-	
-	if (pole_nord) then
-	  ijb=ij_begin+iip1
-	  unat(1:iip1,:)=0.
-	endif
-	
-	if (pole_sud) then 
-	  ije=ij_end-iip1
-	  unat(ij_end-iip1+1:ij_end,:)=0.
-	endif
-	    
+        ijb=ij_begin
+        ije=ij_end
+        
+        if (pole_nord) then
+          ijb=ij_begin+iip1
+          unat(1:iip1,:)=0.
+        endif
+        
+        if (pole_sud) then 
+          ije=ij_end-iip1
+          unat(ij_end-iip1+1:ij_end,:)=0.
+        endif
+            
         do l=1,llm
            unat(ijb:ije,l)=ucov(ijb:ije,l)/cu(ijb:ije)
         enddo
 
-	ijb=ij_begin
-	ije=ij_end
-	if (pole_sud) ije=ij_end-iip1
-	
-	do l=1,llm
+        ijb=ij_begin
+        ije=ij_end
+        if (pole_sud) ije=ij_end-iip1
+        
+        do l=1,llm
            vnat(ijb:ije,l)=vcov(ijb:ije,l)/cv(ijb:ije)
         enddo
@@ -1487,4 +1487,4 @@
         call finalize_parallel
 c$OMP END MASTER
-	RETURN
+        RETURN
       END