Index: /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h	(revision 1044)
+++ /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h	(revision 1045)
@@ -60,26 +60,4 @@
       CALL haut2bas(klon, klev, dem_c, dem_cH2B)
       CALL haut2bas(klon, klevp1, paprs, phalf)
-c
-cIM lecture invtau, tautab des fichiers formattes
-c
-      IF (debut) THEN
-c$OMP MASTER
-c     open(99,file='tautab.bin',access='sequential',
-c    $     form='unformatted',status='old')
-c     read(99) tautab_omp
-c
-      open(99,file='tautab.formatted', FORM='FORMATTED')
-      read(99,'(f30.20)') tautab_omp
-      close(99)
-c
-      open(99,file='invtau.formatted',form='FORMATTED')
-      read(99,'(i10)') invtau_omp
-      close(99)
-c$OMP END MASTER
-c$OMP BARRIER
-      tautab=tautab_omp
-      invtau=invtau_omp
-c
-      ENDIF !debut
 c
 cIM: initialisation de seed
Index: /LMDZ4/trunk/libf/phylmd/ini_histISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histISCCP.h	(revision 1044)
+++ /LMDZ4/trunk/libf/phylmd/ini_histISCCP.h	(revision 1045)
@@ -146,4 +146,9 @@
      .                "ave(X)", zcals(n),zout_isccp(n))
 c
+         CALL histdef(nid_isccp, "meantaucld"//verticaxe(n),
+     .                "ISCCP mean cloud optical thickness", "1",
+     .                iim, jj_nb,nhori,1,1,1,-99,32,
+     .                "ave(X)", zcals(n),zout_isccp(n))
+c
          ENDDO
 c
@@ -168,4 +173,9 @@
           CALL histdef(nid_isccp, "nsunlit"//verticaxe(n),
      .                "Nb of calls with sunlit ", "%",
+     .                iim, jj_nb,nhori,1,1,1,-99,32,
+     .                "ave(X)", zcals(n),zout_isccp(n))
+c
+         CALL histdef(nid_isccp, "meantaucld"//verticaxe(n),
+     .                "ISCCP mean cloud optical thickness", "1",
      .                iim, jj_nb,nhori,1,1,1,-99,32,
      .                "ave(X)", zcals(n),zout_isccp(n))
Index: /LMDZ4/trunk/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phys_output_mod.F90	(revision 1044)
+++ /LMDZ4/trunk/libf/phylmd/phys_output_mod.F90	(revision 1045)
@@ -194,5 +194,4 @@
   integer, dimension(nfiles) , save :: flag_u10_sol      = (/ 10, 4, 10, 10 /)
   integer, dimension(nfiles) , save :: flag_v10_sol      = (/ 10, 4, 10, 10 /)
-  integer, dimension(nfiles) , save :: flag_meantaucld   = (/ 10, 5, 10, 10 /)
   integer, dimension(nfiles) , save :: flag_cldtau       = (/ 10, 5, 10, 10 /)                     
   integer, dimension(nfiles) , save :: flag_cldemi       = (/ 10, 5, 10, 10 /)
@@ -614,7 +613,4 @@
  CALL histdef2d(iff,flag_weakinv, "weakinv","Weak inversion", "-")
  CALL histdef2d(iff,flag_dthmin,"dthmin","dTheta mini", "K/m")
- if (ok_isccp) then
-   CALL histdef2d(iff,flag_meantaucld,"meantaucld","ISCCP mean cloud optical thickness","1")
- endif
  CALL histdef2d(iff,flag_rh2m,"rh2m","Relative humidity at 2m", "%" )
  CALL histdef2d(iff,flag_qsat2m,"qsat2m","Saturant humidity at 2m", "%")
Index: /LMDZ4/trunk/libf/phylmd/phys_output_write.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phys_output_write.h	(revision 1044)
+++ /LMDZ4/trunk/libf/phylmd/phys_output_write.h	(revision 1045)
@@ -664,14 +664,4 @@
       CALL histwrite_phy(nid_files(iff),"dthmin",itau_w,dthmin)
       ENDIF
-
-#ifdef histISCCP
-      IF(ok_isccp) THEN
-       IF (MOD(itap,NINT(freq_ISCCP/dtime)).EQ.0) THEN
-        IF (flag_meantaucld(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"meantaucld",itau_w,meantaucld)
-        ENDIF
-       ENDIF
-      ENDIF !(ok_isccp)
-#endif
 
        IF (flag_cldtau(iff)<=lev_files(iff)) THEN
Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 1044)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 1045)
@@ -1753,5 +1753,5 @@
 c
       IF (MOD(itap-1,lmt_pas) .EQ. 0) THEN
-         WRITE(lunout,*)' PHYS cond  julien ',julien
+         if(prt_level.ge.1) WRITE(lunout,*)' PHYS cond  julien ',julien
          CALL ozonecm( FLOAT(julien), rlat, paprs, wo)
       ENDIF
@@ -2082,6 +2082,6 @@
 
 cIM begin
-        print*,'physiq: cin pbase dnwd0 ftd fqd ',cin(1),pbase(1),
-     .dnwd0(1,1),ftd(1,1),fqd(1,1)
+c       print*,'physiq: cin pbase dnwd0 ftd fqd ',cin(1),pbase(1),
+c    .dnwd0(1,1),ftd(1,1),fqd(1,1)
 cIM end
 cIM cf. FH
@@ -2697,4 +2697,26 @@
       IF (ok_isccp) THEN
 c
+cIM lecture invtau, tautab des fichiers formattes
+c
+      IF (debut) THEN
+c$OMP MASTER
+c
+      open(99,file='tautab.formatted', FORM='FORMATTED')
+      read(99,'(f30.20)') tautab_omp
+      close(99)
+c
+      open(99,file='invtau.formatted',form='FORMATTED')
+      read(99,'(i10)') invtau_omp
+
+c     print*,'calcul_simulISCCP invtau_omp',invtau_omp
+c     write(6,'(a,8i10)') 'invtau_omp',(invtau_omp(i),i=1,100)
+
+      close(99)
+c$OMP END MASTER
+c$OMP BARRIER 
+      tautab=tautab_omp
+      invtau=invtau_omp
+c
+      ENDIF !debut
 c
 cIM appel simulateur toutes les  NINT(freq_ISCCP/dtime) heures
Index: /LMDZ4/trunk/libf/phylmd/write_histISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/write_histISCCP.h	(revision 1044)
+++ /LMDZ4/trunk/libf/phylmd/write_histISCCP.h	(revision 1045)
@@ -29,4 +29,7 @@
         CALL histwrite_phy(nid_isccp,"nsunlit"//verticaxe(n),itau_w,
      .                 nbsunlit(1,:,n))
+c
+       CALL histwrite_phy(nid_isccp,"meantaucld"//verticaxe(n),itau_w,
+     .                 meantaucld(:,n))
 c
         ENDDO ! n=1, napisccp
@@ -71,4 +74,7 @@
      .                 itau_w,nbsunlit(1,:,n))
 c
+       CALL histwrite_phy(nid_isccp,"meantaucld"//verticaxe(n),itau_w,
+     .                 meantaucld(:,n))
+c
         zx_tmp_fi2d(1:klon)=float(seed(1:klon,n))
 c